define([
    "../../store/JsonRest",
    "dojo/Deferred",
    "dojo/_base/declare",
    "dojo/_base/json",
    "dojo/_base/lang",
    "dojo/date/stamp",
    "dojo/store/util/QueryResults"
], function(JsonRest, Deferred, declare, json, lang, stamp, queryResults) {

    var _View = declare([],{
        _collection: null,
        _store: null,
        constructor: function() {
            if ( this._collection === null ) {
                throw new Error("You must specify a concrete collection.");
            }
            this._store = new JsonRest({
                target: '/api/'+this._collection+'/',
                idProperty: '_id'
            });
        },
        _deserializeError: function(err) {
            return new Deferred().reject(json.fromJson(err.responseText));
        },
        _doDeserialize: function(obj) {
            obj = lang.clone(obj);
            return this._deserialize(obj) || obj;
        },
        _deserialize: function(obj) {
            console.warn("You may want to override _deserialize for concrete types.");
        },
        query: function(query) {
            return queryResults(this._store.query(query).map(lang.hitch(this,'_doDeserialize')));
        },
        getId: function(obj) {
            return obj._id;
        },
        getCollectionPath: function() {
            return '/'+this._collection;
        },
        _parseDate: function(str) {
            return stamp.fromISOString(str);
        }
    });

    return _View;

});
