var tv4 = require('tv4');

// from: http://www.w3.org/TR/html5/forms.html#valid-e-mail-address
var html5EmailRe = /^[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/;
var datetimeRe = /^[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}:[0-9]{2}:[0-9]{2}Z/;

tv4.addFormat({
    email: function(data){
        if ( typeof data === "string" && html5EmailRe.test(data) ) {
            return null;
        } else {
            return "Probably an invalid email address.";
        }
    },
    datetime: function(data){
        if ( typeof data === "string" && datetimeRe.test(data) ) {
            return null;
        } else {
            return "Invalid timestamp.";
        }
    }
});

module.exports = tv4.validateResult.bind(tv4);
